      Program SPAPLT
c-Latest date: 06/05/91
c-Generates generic SPA plots from "PXXXXY.DAT" files.
c-Use to plot files from:
c- SPA0401-3,6   SPA0502-8   SPA0602-5,8   SPA0702-12   SPA0801-9
c- SPA0903,5     SPA1103,5-8,10,11         SPA1201-5    SPA1302-8
c- SPA1401-5
      real x(0:1199),y(0:1199,6)
      character name*10
      data name/'PXXXXY.DAT'/
c-Get name of file, open file, and read xy data.
    1 print '(/'' enter XXXXY of PXXXXY.DAT: ''\)'
      read '(a5)', name(2:6)
      open(1,file=name,form='formatted',status='old')
      read(1,'(2i6)') N,NP
      do 2 k=0,N-1
    2  read(1,'(7e15.7)') x(k),(y(k,j),j=1,NP)
c-Make a generic plot.
      do 3 j=1,NP
       iseq=(2-1/j+j/NP)*(1-1/NP)
       if(N.lt.100) call pxy(x,y(0,j),N,1,3,iseq,0,3,.1,.1,.9,.9)
       if(N.ge.100) call pxy(x,y(0,j),N,1,0,iseq,0,3,.1,.1,.9,.9)
    3 continue
      go to 1
      end
c-
      Subroutine Init
c-Initializes SCIPLOT graphics for routines in SDSLIB.
      Parameter (NCRT=1)
      Integer*2 setmod,vecdev(2),vecmod,ie,i0,i15
      Real xs(2),ys(2),xt(2),yt(2)
      Character setnam*64,vecnam*64,c*1
      Data setnam/'c:\LIB\CHRSET04.GRF'/,setmod/2/,vecnam/'VECTOR.GRF'/,
     +     vecdev/10,0/,vecmod/0/,xs/1.,1./,ys/1.0,.92/,xt/0.6,1.4/,
     +     yt/2.,0./,i0/0/,i15/15/
      vecdev(2)=2+2*NCRT
    1 print '(''$Enter s(screen plot) or f(file): '')'
c      read '(a)', c
               c='s'
      i=0
      if(c.eq.'f' .or. c.eq.'F') i=1
      if(c.eq.'s' .or. c.eq.'S') i=2
      if(i.eq.0) go to 1
      call PLTBEG(setnam,setmod,vecnam,vecdev(i),'lpt1',vecmod,ie)
      if(ie.ne.0) then
       print '('' PLTBEG error'',i4)', ie
       stop
      endif
      call FACTOR(0.,xs(i),ys(i),xt(i),yt(i))
      if(NCRT.eq.1) call SETPAL(i0,0)
      if(NCRT.eq.1) call SETCLR(i15)
      return
      end
c-
      SUBROUTINE PXY(X,Y,N,ITYPE,IMODE,ISEQ,ITIC,ILAB,X1,Y1,X2,Y2)
c-Same as PXY in VAX, but using Microglyph Systems SCIPLOT routines.
c-Plot is of Y(N) vs (N).  (If N<4, the plot symbol is a space.)
c-ITYPE =1(linear), 2(log x, lin. y), 3(lin. x, log y), 4(log - log)
c-       5(use previous value).
c-IMODE =0(lines),1(dots),2(dashes),3(points+lines),4(points only).
c-ISEQ  =0(only plot), 1(1st plot), 2(between plot), 3(last plot),
c-       10,11(same as 0,1 but on old screen).
c-ITIC  =0(tics), 1(no tics).
c-ILAB  =0,2(labels), 1(no labels), 3(labels+grid).
c-X1-Y2 =Lwr. left and upr. right corners relative to (0.,0.), (1.,1.).
      Parameter (NCRT=1)
      REAL X(N),Y(N)
      INTEGER*2 i0,NC,IE,WIL,MO,CO,XMJ,XMN,YMJ,YMN,WID,DIG,
     +          TYP,COD,CNT
      Character pltsym*1
      DATA i0/0/,CHT/.10/,COD/1111/
      IF(MOD(ISEQ,10).GT.1) GO TO 7
      if(iseq.le.1) call INIT
      NC=1
      nsym=0
      IF(ILAB.EQ.1) NC=0
      CNT=1
      X0=0.5+6.5*x1
      y0=0.5+6.5*y1
      XL=6.5*(X2-X1)
      YL=6.5*(Y2-Y1)
      MO=MOD(ITYPE+1,2)
      CALL SCALE(X,N,XL,MO,X3,X4,DX,DXL,XMJ,XMN,WID,DIG)
      IF(ITIC.EQ.1) XMJ=0
      CALL AXIS(X0,Y0,' ',NC,CHT,0.,MO,X3,X4,DX,DXL,CHT,XMJ,XMN,WID,
     +          DIG)
      MO=(ITYPE-1)/2
      CALL SCALE(Y,N,YL,MO,Y3,Y4,DY,DYL,YMJ,YMN,WID,DIG)
      IF(ITIC.EQ.1) YMJ=0
      CALL AXIS(X0,Y0,' ',-NC,CHT,90.,MO,Y3,Y4,DY,DYL,CHT,-YMJ,YMN,
     +          WID,DIG)
      TYP=ITYPE-1
      IF(ILAB.EQ.3) CALL GRID(X0,Y0,XL,DXL,XMJ,i0,YL,DYL,YMJ,i0,0.,
     +                        TYP,COD)
    7 CNT=MOD(CNT,5)+1
      if(NCRT.eq.1) call SETCLR(CNT)
      CO=IMODE+1
      if(ITYPE.lt.5) MO=ITYPE-1
      pltsym=char(nsym+16)
      if(N.lt.4) pltsym=' '
      CALL DRAW(X,Y,N,MO,CO,pltsym,.09,X0,Y0,XL,YL,X3,X4,Y3,Y4)
      nsym=mod(nsym+1,16)
      IF(ISEQ.EQ.0.OR.ISEQ.EQ.3) CALL PLTEND(WIL,IE)
      RETURN
      END
c-
      Subroutine TEXT(string,length,height,x,y)
C-string = Character string to be printed on plot.
C-length = Length (# characters).
C-height = Height of characters (inches).
C-x,y    = coordinates of beginning of string on plot.
C-itype  = same as in PXY.
C-
      character string*80
      real xp(2),yp(2)
      xp(1)=x
      xp(2)=x
      yp(1)=y
      yp(2)=y
      call PXY(xp,yp,2,5,4,2,0,0,0.,0.,0.,0.)
      call WHERE(x1,y1,angle,xs,ys,xt,yt)
      call SYMBOL(x1,y1,height,string,angle,length)
      return
      end
