function y=spbfct(m,n)
% y=spbfct(m,n)
% Generates (m)!/(m-n)!.
% Note:  0!=1 and spbfct(m,m)=spbfct(m,m-1)=m!.
% Inputs:
%    m,n  = Input scalars.
% Outputs:  
%    y    = (m)!/(m-n)!.

if (m<0) | (n<0) | (n>m),
   error('SPBFCT: m or n <0, or n>m.');
end
if n==0,
   y=1;
   return
end
y=prod(m:-1:m-n+1);
return
