function y=spfirf(b,x)
% y=spfirf(b,x)
% Fast FFT filter of row vector x using weights b.
% Transfer function is
%      H(z)=b(1)+b(2)*z^(-1)+...+b(M)*z^(-(N-1))
% Inputs:
%   b = B(z) weights row vector of any length.
%   x = input signal vector of any length.
% Output:
%   y = output row vector, same length as x.

y=spconv(b,x);
y=y(1:length(x));
end
