function [a,b]=splfit(x,y)
% [a,b]=splfit(x,y)
% Fits straight line given by y=a*x+b to the data
% in row vectors x and y, of equal length.
% a and b are the scalar coefficients in y=a*x+b.

N=length(x);
if (N<2) | (length(y)~=N),
   error('SPLFIT: x and y lengths unequal or <2.');
end
xysum=x*y';
xsum=sum(x);
ysum=sum(y);
x2sum=x*x';
den=N*x2sum-xsum^2;
a=(N*xysum-xsum*ysum)/den;
b=mean(y)-a*mean(x);
return
