function b=sppoly(dx,y,L)
% b=sppoly(dx,y,L)
% Polynomial coefficients for least squares fit.
% dx=x interval; y=data row vector; L=order of 
% polynomial; b=coefficient column vector.
% Inputs:
%  dx = x interval. x values assumed to be [0, dx, 2dx, ...].
%  y  = row vector of equally spaced samples y(x).
%  L  = order of system of equations; scalar.
% Outputs:  
%  b  = coeff. in b0 + b1*x + ... + bL*x^L  (column vector).

if dx<=0,
   error('SPPOLY: dx is not greater than 0.');
end
[b,P]=sporth(y,L);
S=spstrl(L);
b=(S'*P'*b) .* (dx.^(0:-1:-L))';
return
