function S=spstrl(L)
% S=spstrl(L)
% S= (L+1)x(L+1) matrix of Stirling numbers
% of the first kind.  See equation 11.21.
%
% Inputs:
%    L  = order of S; scalar.
% Outputs:  
%    S  = Stirling matrix; 

S=tril(ones(L+1));
S(2:L+1,1)=zeros(L,1);
for i=2:L,
   S(i+1,2)=-(i-1)*S(i,2);
end
for i=3:L,
   for j=2:i-1,
      S(i+1,j+1)=S(i,j)-(i-1)*S(i,j+1);
   end
end
return
