% SPA0506:  Phase shift plots for noncausal systems
%           H3(Z) and H4(Z).

b=[-0.2,0.4,0.8,-0.4,0.2]; d=[0.2]; c=[1,-0.8];
freq=[0 : 0.5/300 : 0.5];
h3=spgain(b,1,freq);
h4=spgain(d,c,freq);
phase3=atan2(imag(h3),real(h3))+4*pi*freq;
phase4=atan2(imag(h4),real(h4))+2*pi*freq;

plot(freq,[phase3' spunwr(phase3,1)' phase4'],'w');...
   title('Figure 5.9');...
   xlabel('Frequency (Sampling Frequency = 1.0)');...
   ylabel('Phase Shift (Rad)');...
   grid

