% SPA0703:  Lowpass analog to highpass digital.
iband=2; fl=3500; fh=0; T=0.0001;
d=[1,0,0]; c=[1,1.41421,1];
fln=fl*T;
fhn=fh*T;
[b,a]=spfblt(d,c,iband,fln,fhn);
freq=[0:500]*0.5/500;
amp=abs(spgain(b,a,freq));

fprintf('B(z) coefficients:  %10.4f%10.4f%10.4f\n',b(1:3));
fprintf('A(z) coefficients:  %10.4f%10.4f%10.4f\n',a(1:3));
plot([0:500]/100,amp,'w'); grid;...
   title('Figure 7.5');...
   xlabel('Frequency (kHz)');...
   ylabel('Magnitude');
end
