% SPA0704:  Lowpass analog to bandpass digital.
iband=3; fl=1500; fh=3500; T=0.0001;
d=[1,0,0,0,0]; c=[1,1.41421,1,0,0];
fln=fl*T;
fhn=fh*T;
[b,a]=spfblt(d,c,iband,fln,fhn);
freq=[0:500]*0.5/500;
amp=abs(spgain(b,a,freq));

fprintf('B(z) coefficients:');...
fprintf('%8.4f',b(1:5));...
fprintf('\nA(z) coefficients:');...
fprintf('%8.4f',a(1:5));...
fprintf('\n');
plot([0:500]/100,amp,'w'); grid;...
   title('Figure 7.6');...
   xlabel('Frequency (kHz)');...
   ylabel('Magnitude');
end
