% SPA0707: Design of 8th order bandpass Butterworth filter.
iband=3; fl=1500; fh=3500; T=0.0001; L=8;
freq=[0:200]*0.5/200;
amp=ones(1,201);
fln=fl*T;  fhn=fh*T;
for k=1:2,
   [d,c]=spbwcf(L/2,k);
   [b,a]=spfblt(d,c,iband,fln,fhn);
   amp=amp .* abs(spgain(b,a,freq));
   fprintf('Section %2g Coefficients:\nb(1:5):',k);...
   fprintf('%8.4f',b(1:5));...
   fprintf('\na(1:5):');...
   fprintf('%8.4f',a(1:5));...
   fprintf('\n');
end
plot([0:200]*5/200,amp,'w'); grid;...
title('Figure 7.11');...
xlabel('Frequency (kHz)');...
ylabel('Amplitude gain');
end
