% SPA1105: Data fitting via orthogonal polynomials.
N=51; L=5; dx=1/(N-1);
x=[0:N-1]/(N-1);
rand('seed',123);
y=-1 - 5*x - 3*x.^2 + 10*x.^3 + 0.4*(rand(1,N)-0.5);
[orthb,P]=sporth(y,L);
b=sppoly(dx,y,L);
fprintf('           POLYNOMIAL COEFFICIENTS\n');
for i=1:L+1,
   fprintf(' orthb(%1g) = %8.4f',i-1,orthb(i));...
   fprintf('         b(%1g) = %5.2f\n',i-1,b(i));...
end
p=b(1)+b(2)*x+b(3)*x.^2+b(4).*x.^3+b(5)*x.^4+b(6)*x.^5;
plot(x,y,'wo',x,p,'w'); grid;
xlabel('x'); ylabel('[yk], polynomial');
title('SPA1105: 5th-order l.s. polynomial fit');
