% SPA1203: Adaptive interference cancelling.
N=501; rand('seed',123);
L=4; b=zeros(1,L+1);
mu=0.1; alpha=0; sigma=0.005; px=0;
t=[0:N-1]; arg=2*pi*t/20;
s=(1 + 0.01*t) .* sin(arg + pi/3);
x=0.1*sin(arg);
d=s+sqrt(12)*(rand(1,N)-0.5);
figure(1); plot([0:250],d(1:251),'w'); grid;...
      title('Figure 12.9');...
      xlabel('Time');...
      ylabel('Amplitude');...
[y,b,px]=spnlms(x,d,b,mu,sigma,alpha,px);
figure(2); plot([0:250],s(1:251),'-w',...
                [0:250],x(1:251),':w',...
                [0:250],y(1:251),'--w'); grid;...
   title('Figure 12.10(a):  Initial convergence');...
   xlabel('Time');...
   ylabel('Amplitude');...
tb=[251:500];
figure(3); plot([251:500],s(252:501),'-w',...
                [251:500],y(252:501),'--w'); grid;...
   title('Figure 12.10(b):  Tracking performance');...
   xlabel('Time');...
   ylabel('Amplitude');
