% SPA1205: Adaptive design of an FIR filter.
M=41; N=501; L=50; mu=0.6; alpha=0; sigma=1+40*sqrt(2);
b=zeros(1,L+1); px=0;
amp=[ones(1,(M-1)/2),0.5,zeros(1,(M-1)/2)];
x=zeros(1,N); d=zeros(1,N);
for k=0:N-1,
   d(k+1)=sum(amp(1:41).*sin(2*pi*[0:40]*(k-L/2)/80));
   x(k+1)=sum(sin(2*pi*[0:40]*k/80));
end
[y,b,px]=spnlms(x,d,b,mu,sigma,alpha,px);
gain=abs(spgain(b,1,(0:300)*0.5/300));
figure(1); plot([0:300]*0.5/300,gain,'w'); grid;...
   title('Figure 12.15: Desired and adaptive ampl. gains');
   xlabel('Frequency (Hz)');...
   ylabel('Amplitude gain');...
   hold on;...
   plot([0:40]/80,amp,'ow');...
   hold off
figure(2); plot([0:L],b,'ow'); grid;...
   title('Figure 12.16: Impulse response of H(z) and model');
   xlabel('Sample Number');...
   ylabel('Amplitude');
   epsilon=max(1e-5,(d-y).^2);
figure(3); semilogy([0:N-1],epsilon,'w');...
   title('Figure 12.17: Squared error vs sample number');
   xlabel('Sample Number');...
   ylabel('Epsilon squared')
